Package org.springframework.context.annotation

# Annotation Interface Lazy

@Target({TYPE,METHOD,CONSTRUCTOR,PARAMETER,FIELD}) @Retention(RUNTIME) @Documented public @interface Lazy
Indicates whether a bean is to be lazily initialized.

May be used on any class directly or indirectly annotated with `@Component` or on methods annotated with `@Bean`.

If this annotation is not present on a `@Component` or `@Bean` definition, eager initialization will occur. If present and set to `true`, the `@Bean` or `@Component` will not be initialized until referenced by another bean or explicitly retrieved from the enclosing `BeanFactory`. If present and set to `false`, the bean will be instantiated on startup by bean factories that perform eager initialization of singletons.

If Lazy is present on a `@Configuration` class, this indicates that all `@Bean` methods within that `@Configuration` should be lazily initialized. If `@Lazy` is present and `false` on a `@Bean` method within a `@Lazy`-annotated `@Configuration` class, this indicates overriding the 'default lazy' behavior and that the bean should be eagerly initialized.

In addition to its role for component initialization, this annotation may also be placed on injection points marked with `Autowired` or `Inject`: In that context, it leads to the creation of a lazy-resolution proxy for the affected dependency, caching it on first access in case of a singleton or re-resolving it on every access otherwise. This is an alternative to using `ObjectFactory` or `Provider`. Please note that such a lazy-resolution proxy will always be injected; if the target dependency does not exist, you will only be able to find out through an exception on invocation. As a consequence, such an injection point results in unintuitive behavior for optional dependencies. For a programmatic equivalent, allowing for lazy references with more sophistication, consider `ObjectProvider`.

Since:
  3.0
Author:
  Chris Beams, Juergen Hoeller
See Also:
  - `Primary`
  - `Bean`
  - `Configuration`
  - `Component`

## Optional Element Summary

Optional Elements
Modifier and Type
Optional Element
Description
`boolean`
`value`
Whether lazy initialization should occur.

## Element Details

### value

boolean value
Whether lazy initialization should occur.

Default:
  true